def factorial(n: int) -> int:
    if n == 0:
        return 1
    else:
        return n * factorial(n - 1)


def factorial2(n: int) -> int:
    r = 1
    for i in range(2, n+1):
        r = r * i
    return r


def length[A](l: list[A]) -> int:
    match l:
        case [_, *t]:
            return 1 + length(t)
        case _:
            return 0


def length2[A](l: list[A]) -> int:
    count = 0
    for _ in l:
        count += 1
    return count


def hd[A](l: list[A]) -> A:
    match l:
        case [h, *_]:
            return h
        case _:
            raise ValueError


def head[A](l: list[A]) -> A | None:
    match l:
        case [h, *_]:
            return h
        case _:
            return None


def get_item[A](l: list[A]) -> tuple[A, list[A]] | None:
    match l:
        case [h, *t]:
            return (h, t)
        case _:
            return None


def last[A](l: list[A]) -> A:
    match l:
        case [h]:
            return h
        case [_, *t]:
            return last(t)
        case _:
            raise ValueError


def nth[A](l: list[A], i: int) -> A:
    match l:
        case [h, *t]:
            if i == 0:
                return h
            else:
                return nth(t, i - 1)
        case _:
            raise IndexError


def take[A](l: list[A], i: int) -> list[A]:
    if i == 0:
        return []
    else:
        match l:
            case [h, *t]:
                return [h, *take(t, i - 1)]
            case _:
                raise IndexError


def drop[A](l: list[A], i: int) -> list[A]:
    if i == 0:
        return l
    else:
        match l:
            case [_, *t]:
                return drop(t, i - 1)
            case _:
                raise IndexError


def reversed[A](l: list[A]) -> list[A]:
    match (l):
        case [h, *t]:
            return reversed(t) + [h]
        case _:
            return []


def reversed2[A](l: list[A]) -> list[A]:
    result: list[A] = []
    for x in l:
        result.insert(0, x)
    return result


def concat[A](l: list[list[A]]) -> list[A]:
    match (l):
        case [h, *t]:
            return h + concat(t)
        case _:
            return []


def concat2[A](l: list[list[A]]) -> list[A]:
    result: list[A] = []
    for xs in l:
        result += xs
    return result


def zip[A, B](l1: list[A], l2: list[B]) -> list[tuple[A, B]]:
    match l1, l2:
        case [h1, *t1], [h2, *t2]:
            return [(h1, h2), *zip(t1, t2)]
        case _, _:
            return []


def unzip[A, B](l: list[tuple[A, B]]) -> tuple[list[A], list[B]]:
    match l:
        case [(h1, h2), *t]:
            (t1, t2) = unzip(t)
            return ([h1, *t1], [h2, *t2])
        case _:
            return ([], [])
